@use 'partials/variables/mobile-screen';
@use 'partials/variables/grid';
@use 'partials/functions/calculations';
@use 'partials/mixins/card'as mixin;

$full-width: 100%;

// the app description is 6 columns wide with 5 gaps in between
$app-description-column-count: 6;
$app-description-width: calculations.calculateRatio(
  calculations.calculateWidth(
    grid.$grid-desktop-column-width,
    grid.$grid-desktop-column-gap,
    $app-description-column-count,
    $app-description-column-count - 1
  ),
  grid.$grid-desktop-full-container-width,
  $full-width
);

$vendor-logo-column-count: 1;
$vendor-logo-size: calculations.calculateRatio(
    calculations.calculateWidth(
      grid.$grid-desktop-column-width,
      grid.$grid-desktop-column-gap,
      $vendor-logo-column-count,
      0
  ),
  grid.$grid-desktop-full-container-width,
  50%
);


// the app workflow container is 8 columns wide with 9 gaps, 7 gaps in between an 2 gaps outside of the grid
$app-workflow-column-count: 8;
$app-workflow-width: calculations.calculateRatio(
  calculations.calculateWidth(
    grid.$grid-desktop-column-width,
    grid.$grid-desktop-column-gap,
    $app-workflow-column-count,
    $app-workflow-column-count + 1
  ),
  grid.$grid-desktop-full-container-width,
  $full-width
);

.app-detail-container {
  display: flex;
  justify-content: center;
}

.inner-app-container {
  display: flex;
  flex-direction: column;
  align-items: center;
}

.app-detail-header {
  display: flex;
  justify-content: center;
  align-items: center;
  position: relative;
}

.back-button {
  position: absolute;
  left: 0;
}

.back-icon {
  transform: scale(1.3);
}

.img-comp-container {
  display: flex;
}

.complete-width {
  width: $full-width;
}

.description-container {
  width: $app-description-width;
  padding: 1em;
  // white-space: pre-line;
}

.divider-full-width {
  width: 98vw;
  border-top-width: 2px;
}

.workflow-container {
  display: inline-block;
  width: $app-workflow-width;
  padding-top: 1rem;
}

.banner-fallback {
  max-width: 400px;
}

.tags-container {
  width: $app-description-width;
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: flex-start;
  padding: 1rem 1rem 0;
}

.tag-item {
  flex: 1;
}

.break-row {
  flex-basis: $full-width;
  height: 0;
}

.vendor-container {
  display: flex;
  align-items: center;
  margin: 1rem;
}

.vendor-link {
  display: flex;
  align-items: center;
}

.app-vendor-logo {
  object-fit: contain;
  border-radius: 50%;
  aspect-ratio: 1/1;
  width: 50px;
}


h1 {
  text-align: center;
}

.api-version-container {
  display: flex;
  justify-content: center;
  align-items: center;
}

.api-versions-spacing {
  margin: 1rem;
  display: flex;
  align-items: baseline;
}


.api-versions-label {
  text-align: center;
  font-weight: bold;
  margin-bottom: 0.5rem;
}

.vendor-link-container {
  display: flex;
  align-items: center;
  column-gap: 12px;
}


@media only screen and (max-width: mobile-screen.$max-tablet-width) and (min-width: mobile-screen.$max-mobile-width) {
  .workflow-container {
    width: $app-description-width;
  }
}

@media only screen and (max-width: mobile-screen.$max-mobile-width) {
  .inner-app-container {
    min-width: 0;
  }

  .app-detail-header {
    width: $full-width;
  }

  .back-button {
    display: none;
  }

  .img-comp-container {
    width: $full-width;
  }

  .description-container {
    width: $full-width;
  }

  .description-container > p {
    line-height: mobile-screen.$mobile-line-width;
  }

  h2 {
    text-align: center;
  }

  .tags-container {
    width: $full-width;
    flex-direction: column;
    flex-wrap: nowrap;
    align-items: center;
  }

  .workflow-container {
    width: $full-width;
  }

  .api-versions-spacing {
    flex-direction: column;
    align-items: center;
  }
}
